package kaysaar.aotd_question_of_loyalty.data.intel;

import com.fs.starfarer.api.ui.UIPanelAPI;
import ashlib.data.plugins.ui.models.BasePopUpDialog;
import kaysaar.aotd_question_of_loyalty.data.plugins.ProductionUtil;
import com.fs.starfarer.api.campaign.CustomUIPanelPlugin;
import kaysaar.aotd_question_of_loyalty.data.intel.dialog.RebelionEventDialog;
import com.fs.starfarer.api.ui.IntelUIAPI;
import com.fs.starfarer.api.campaign.CommDirectoryEntryAPI;
import kaysaar.aotd_question_of_loyalty.data.plugins.ReflectionUtilis;
import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.impl.campaign.econ.impl.OrbitalStation;
import com.fs.starfarer.api.campaign.econ.Industry;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.impl.campaign.intel.BaseIntelPlugin;
import com.fs.starfarer.api.impl.campaign.intel.MessageIntel;
import com.fs.starfarer.api.ui.EventProgressBarAPI;
import java.util.Collections;
import com.fs.starfarer.api.ui.UIComponentAPI;
import com.fs.starfarer.api.ui.CustomPanelAPI;
import kaysaar.aotd_question_of_loyalty.data.plugins.AoTDNexMarketUtil;
import kaysaar.aotd_question_of_loyalty.data.listeners.AoTDFreeStorageComm;
import data.kaysaar.aotd.vok.campaign.econ.globalproduction.models.GPManager;
import kaysaar.aotd_question_of_loyalty.data.tags.AoTDRankTags;
import com.fs.starfarer.api.characters.PersonAPI;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.impl.campaign.rulecmd.missions.Commission;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import com.fs.starfarer.api.ui.ButtonAPI;
import com.fs.starfarer.api.ui.CutStyle;
import com.fs.starfarer.api.campaign.ReputationActionResponsePlugin;
import com.fs.starfarer.api.campaign.comm.CommMessageAPI;
import com.fs.starfarer.api.impl.campaign.CoreReputationPlugin;
import java.util.Set;
import java.util.Collection;
import com.fs.starfarer.api.campaign.econ.MarketAPI;
import java.util.LinkedHashSet;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionUtil;
import kaysaar.aotd_question_of_loyalty.data.intel.eventfactors.monthly.MonthlyObligationFactor;
import kaysaar.aotd_question_of_loyalty.data.models.RankData;
import com.fs.starfarer.api.EveryFrameScript;
import com.fs.starfarer.api.campaign.comm.IntelInfoPlugin;
import com.fs.starfarer.api.campaign.TextPanelAPI;
import java.util.ArrayList;
import com.fs.starfarer.api.campaign.econ.MonthlyReport;
import com.fs.starfarer.api.impl.campaign.shared.SharedData;
import java.util.List;
import com.fs.starfarer.api.impl.campaign.rulecmd.AoTDRetirementOption;
import kaysaar.aotd_question_of_loyalty.data.models.RetirementInfo;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.ui.Alignment;
import kaysaar.aotd_question_of_loyalty.data.tags.AoTDCommisionTags;
import com.fs.starfarer.api.util.Misc;
import com.fs.starfarer.api.ui.TooltipMakerAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.impl.campaign.intel.events.EventFactor;
import java.util.Iterator;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionDataManager;
import com.fs.starfarer.api.impl.campaign.intel.FactionCommissionIntel;
import java.util.LinkedHashMap;
import java.awt.Color;
import kaysaar.aotd_question_of_loyalty.data.models.BaseFactionCommisionData;
import com.fs.starfarer.api.campaign.listeners.EconomyTickListener;
import com.fs.starfarer.api.impl.campaign.intel.events.BaseEventIntel;

public class AoTDCommIntelPlugin extends BaseEventIntel implements EconomyTickListener
{
    BaseFactionCommisionData data;
    public static Color optionColor;
    public static Color BAR_COLOR;
    public static String RESEARCH_KEY;
    public String currentRank;
    public static String RANK_KEY;
    protected LinkedHashMap<String, FactionCommissionIntel.RepChangeData> repChanges;
    boolean commisionValid;
    
    public AoTDCommIntelPlugin() {
        this.repChanges = new LinkedHashMap<String, FactionCommissionIntel.RepChangeData>();
        this.commisionValid = true;
    }
    
    public String getRank() {
        return this.data.getFaction().getMemoryWithoutUpdate().getString(AoTDCommIntelPlugin.RANK_KEY);
    }
    
    public void setRank(final String id) {
        this.data.getFaction().getMemory().set(AoTDCommIntelPlugin.RANK_KEY, (Object)id);
    }
    
    public void unset() {
        this.data.getFaction().getMemory().unset(AoTDCommIntelPlugin.RANK_KEY);
    }
    
    public void updateData() {
        final String factionId = this.data.factionID;
        this.data = AoTDCommissionDataManager.getInstance().getCommisionData(factionId);
        boolean timeToBreak = false;
        for (final BaseEventIntel.EventStageData stage : this.stages) {
            if (timeToBreak) {
                break;
            }
            if (stage.id.equals(this.getRank())) {
                timeToBreak = true;
            }
            stage.wasEverReached = true;
        }
    }
    
    public void setData(final BaseFactionCommisionData data) {
        this.data = data;
    }
    
    public static void addFactorCreateIfNecessary(final EventFactor factor, final InteractionDialogAPI dialog) {
        if (get() == null) {
            return;
        }
        if (get() != null) {
            get().addFactor(factor, dialog);
        }
    }
    
    public FactionAPI getCurrentlyCommisonedFaction() {
        return this.data.getFaction();
    }
    
    public void printInfo(final InteractionDialogAPI dialogAPI, final TooltipMakerAPI info) {
        final Color h = Misc.getHighlightColor();
        final Color g = Misc.getGrayColor();
        final float pad = 3.0f;
        final float opad = 10.0f;
        final FactionAPI faction = this.data.getFaction();
        final FactionCommissionIntel temp = new FactionCommissionIntel(faction);
        info.setParaSmallInsignia();
        final BaseFactionCommisionData daten = AoTDCommissionDataManager.getInstance().getCommisionData(faction.getId());
        if (Misc.getPlayerMarkets(true).isEmpty() || this.data.hasTag(AoTDCommisionTags.DOES_NOT_CARE_ABOUT_PLAYER_COLONIES)) {
            info.addPara("基于你现在的条件，你可以从 %s开始做起 ，可以领取每月 %s的salary", 5.0f, Color.ORANGE, new String[] { daten.getRankFromString(daten.getFirstDefRank()).name, Misc.getDGSCredits((float)daten.getRankFromString(daten.getFirstDefRank()).salary) });
        }
        else {
            info.addPara("基于你现在的条件，你可以从 %s开始做起 ，可以领取每月 %s的salary", 5.0f, Color.ORANGE, new String[] { daten.getAdequateRankForColonies(Misc.getPlayerMarkets(true).size()).name, Misc.getDGSCredits((float)daten.getAdequateRankForColonies(Misc.getPlayerMarkets(true).size()).salary) });
            info.addPara("We propose such rank due to your colonial holdings", Color.ORANGE, 5.0f);
        }
        info.addSectionHeading("Commission Progression", Alignment.MID, 10.0f);
        info.setParaFontDefault();
        info.addPara("To progress through our ranks you need to prove a worthy asset to our faction.You can do by:", 10.0f);
        info.addPara("Selling AI Cores to our faction", 3.0f);
        if (Global.getSettings().getModManager().isModEnabled("aotd_vok")) {
            info.addPara("Selling Research databanks to our faction", 3.0f);
        }
        info.addPara("Completing survey missions and analyze missions", 3.0f);
        info.addPara("Completing faction bounties", 3.0f);
        info.addPara("Catching smugglers within faction's star systems", 3.0f);
        info.addPara("Making profitable trades with our faction", 3.0f);
        info.setParaSmallInsignia();
        final List<FactionAPI> hostile = temp.getHostileFactions();
        if (hostile.isEmpty()) {
            info.addPara(Misc.ucFirst(faction.getDisplayNameWithArticle()) + " is not currently hostile to any major factions.", 0.0f);
        }
        else {
            info.addPara(Misc.ucFirst(faction.getDisplayNameWithArticle()) + " is currently hostile to:", opad);
            info.setParaFontDefault();
            info.setBulletedListMode("      ");
            float initPad = opad;
            for (final FactionAPI other : hostile) {
                info.addPara(Misc.ucFirst(other.getDisplayName()), other.getBaseUIColor(), initPad);
                initPad = 3.0f;
            }
            info.setBulletedListMode((String)null);
        }
        if (this.hasRetiredFromFaction()) {
            info.addPara("We do have records of your previous service within our ranks. We will look forward towards fruitful cooperation.", Misc.getPositiveHighlightColor(), 10.0f);
        }
        else {
            info.addPara("Should you prove to be burden to our faction, we will terminate this contract", Misc.getNegativeHighlightColor(), 10.0f);
        }
        dialogAPI.getTextPanel().addTooltip();
        if (this.hasRetiredFromAnyFaction() && !this.hasRetiredFromFaction()) {
            final RetirementInfo retirementInfo = (RetirementInfo)Global.getSector().getMemory().get(AoTDRetirementOption.memKey);
            final FactionAPI factionAPI = Global.getSector().getFaction(retirementInfo.getPrevFaction());
            dialogAPI.getTextPanel().addPara(factionAPI.getDisplayName() + " will treat our action as treason!", Misc.getNegativeHighlightColor());
        }
    }
    
    public boolean hasRetiredFromAnyFaction() {
        return Global.getSector().getMemory().contains(AoTDRetirementOption.memKey);
    }
    
    public boolean hasRetiredFromFaction() {
        if (this.hasRetiredFromAnyFaction()) {
            final RetirementInfo info = (RetirementInfo)Global.getSector().getMemory().get(AoTDRetirementOption.memKey);
            return info.getPrevFaction().equals(this.data.getFaction().getId());
        }
        return false;
    }
    
    public boolean isSteppingIntoNoReturn() {
        return !Misc.getPlayerMarkets(true).isEmpty() && !this.data.hasTag(AoTDCommisionTags.DOES_NOT_CARE_ABOUT_PLAYER_COLONIES);
    }
    
    public void reportEconomyTick(final int iterIndex) {
        super.reportEconomyTick(iterIndex);
        final float numIter = Global.getSettings().getFloat("economyIterPerMonth");
        final float f = 1.0f / numIter;
        final MonthlyReport report = SharedData.getData().getCurrentReport();
        final MonthlyReport.FDNode fleetNode = report.getNode(new String[] { MonthlyReport.FLEET });
        fleetNode.name = "Fleet";
        fleetNode.custom = MonthlyReport.FLEET;
        fleetNode.tooltipCreator = (TooltipMakerAPI.TooltipCreator)report.getMonthlyReportTooltip();
        final FactionAPI faction = this.data.getFaction();
        final float stipend = (float)this.getCurrentRankData().salary;
        final MonthlyReport.FDNode node;
        final MonthlyReport.FDNode stipendNode = node = report.getNode(fleetNode, new String[] { "node_id_stipend_" + this.data.getFaction().getId() });
        node.income += stipend * f;
        if (stipendNode.name == null) {
            stipendNode.name = faction.getDisplayName() + " Commission";
            stipendNode.icon = faction.getCrest();
            stipendNode.tooltipCreator = (TooltipMakerAPI.TooltipCreator)new TooltipMakerAPI.TooltipCreator() {
                public boolean isTooltipExpandable(final Object tooltipParam) {
                    return false;
                }
                
                public float getTooltipWidth(final Object tooltipParam) {
                    return 450.0f;
                }
                
                public void createTooltip(final TooltipMakerAPI tooltip, final boolean expanded, final Object tooltipParam) {
                    tooltip.addPara("Your monthly stipend for holding a " + faction.getDisplayName() + " commission", 0.0f);
                }
            };
        }
    }
    
    public void reportEconomyMonthEnd() {
        super.reportEconomyMonthEnd();
    }
    
    public static AoTDCommIntelPlugin get() {
        return (AoTDCommIntelPlugin)Global.getSector().getMemoryWithoutUpdate().get(AoTDCommIntelPlugin.RESEARCH_KEY);
    }
    
    public BaseFactionCommisionData getData() {
        return this.data;
    }
    
    public List<FactionAPI> getHostileFactions() {
        final FactionAPI player = Global.getSector().getPlayerFaction();
        final List<FactionAPI> hostile = new ArrayList<FactionAPI>();
        for (final FactionAPI other : this.getRelevantFactions()) {
            if (this.data.getFaction().isHostileTo(other)) {
                hostile.add(other);
            }
        }
        return hostile;
    }
    
    public static Object getAsPureObj() {
        return Global.getSector().getMemoryWithoutUpdate().get(AoTDCommIntelPlugin.RESEARCH_KEY);
    }
    
    public void initializeFully(final BaseFactionCommisionData contract, final TextPanelAPI text, final boolean withIntelNotification, final String startingRankId, final String firstOfficialRank) {
        this.data = contract;
        this.progress = 10;
        final boolean havePlanets = !Misc.getPlayerMarkets(false).isEmpty();
        if (havePlanets && !this.data.hasTag(AoTDCommisionTags.DOES_NOT_CARE_ABOUT_PLAYER_COLONIES)) {
            this.setRank(this.data.getAdequateRankForColonies(Misc.getPlayerMarkets(true).size()).id);
            this.progress = this.data.rankValue.get(this.data.getAdequateRankForColonies(Misc.getPlayerMarkets(true).size()).id) + 10;
        }
        else {
            this.setRank(startingRankId);
        }
        this.setup();
        Global.getSector().getMemoryWithoutUpdate().set(AoTDCommIntelPlugin.RESEARCH_KEY, (Object)this);
        this.setSortTier(IntelInfoPlugin.IntelSortTier.TIER_2);
        Global.getSector().addScript((EveryFrameScript)this);
        Global.getSector().getListenerManager().addListener((Object)this);
        Global.getSector().getIntelManager().addIntel((IntelInfoPlugin)this, !withIntelNotification, text);
    }
    
    protected void notifyEnded() {
        super.notifyEnded();
        Global.getSector().getIntelManager().removeIntel((IntelInfoPlugin)this);
        Global.getSector().getMemoryWithoutUpdate().unset(AoTDCommIntelPlugin.RESEARCH_KEY);
    }
    
    protected void setup() {
        this.factors.clear();
        this.stages.clear();
        this.setMaxProgress(this.data.maxProgress);
        for (final RankData rank : this.data.ranks) {
            this.addStage((Object)rank.id, (int)this.data.rankValue.get(rank.id), BaseEventIntel.StageIconSize.SMALL);
            this.getDataFor((Object)rank.id).keepIconBrightWhenLaterStageReached = true;
        }
        this.stages.get(this.stages.size() - 1).isOneOffEvent = true;
        this.addFactor((EventFactor)new MonthlyObligationFactor());
    }
    
    protected void addBulletPoints(final TooltipMakerAPI info, final IntelInfoPlugin.ListInfoMode mode, final boolean isUpdate, final Color tc, final float initPad) {
        if (!this.addEventFactorBulletPoints(info, mode, isUpdate, tc, initPad)) {
            final Color h = Misc.getHighlightColor();
            if (isUpdate && this.getListInfoParam() instanceof BaseEventIntel.EventStageData) {
                final BaseEventIntel.EventStageData esd = (BaseEventIntel.EventStageData)this.getListInfoParam();
                if (!esd.wasEverReached) {
                    if (!this.data.hasTag(AoTDCommisionTags.UP_RANK_AUTOMATICALLY)) {
                        info.addPara("You have earned right to become %s", 0.0f, Color.ORANGE, new String[] { this.getRankForID(this.getStageId(esd.id)).name });
                    }
                    else {
                        info.addPara("You are now %s", 0.0f, Color.ORANGE, new String[] { this.getRankForID(this.getStageId(esd.id)).name });
                        this.setRank(this.getStageId(esd.id));
                        AoTDCommissionUtil.reportPlayerGotNewRank(this.getCurrentRankData());
                    }
                }
            }
        }
    }
    
    public List<FactionAPI> getRelevantFactions() {
        final Set<FactionAPI> factions = new LinkedHashSet<FactionAPI>();
        for (final MarketAPI market : Global.getSector().getEconomy().getMarketsCopy()) {
            if (market.isHidden()) {
                continue;
            }
            final FactionAPI curr = market.getFaction();
            if (factions.contains(curr)) {
                continue;
            }
            if (!curr.isShowInIntelTab()) {
                continue;
            }
            factions.add(curr);
        }
        return new ArrayList<FactionAPI>(factions);
    }
    
    public void makeRepChanges(final InteractionDialogAPI dialog) {
        final FactionAPI player = Global.getSector().getPlayerFaction();
        for (final FactionAPI other : this.getRelevantFactions()) {
            final FactionCommissionIntel.RepChangeData change = this.repChanges.get(other.getId());
            final boolean madeHostile = change != null;
            final boolean factionHostile = this.data.getFaction().isHostileTo(other);
            final boolean playerHostile = player.isHostileTo(other);
            if (factionHostile && !playerHostile && !madeHostile) {
                this.makeHostile(other, dialog);
            }
            if (!factionHostile && madeHostile) {
                this.undoRepChange(other, dialog);
            }
        }
    }
    
    public void makeHostile(final FactionAPI other, final InteractionDialogAPI dialog) {
        final ReputationActionResponsePlugin.ReputationAdjustmentResult rep = Global.getSector().adjustPlayerReputation((Object)new CoreReputationPlugin.RepActionEnvelope(CoreReputationPlugin.RepActions.MAKE_HOSTILE_AT_BEST, (Object)null, (CommMessageAPI)null, (dialog != null) ? dialog.getTextPanel() : null, false, true), other.getId());
        final FactionCommissionIntel.RepChangeData data = new FactionCommissionIntel.RepChangeData();
        data.faction = other;
        data.delta = rep.delta;
        this.repChanges.put(other.getId(), data);
    }
    
    public void makeVengeful(final FactionAPI factionAPI, final InteractionDialogAPI dialog) {
        final CoreReputationPlugin.CustomRepImpact impact = new CoreReputationPlugin.CustomRepImpact();
        impact.delta = -10.0f;
        Global.getSector().adjustPlayerReputation((Object)new CoreReputationPlugin.RepActionEnvelope(CoreReputationPlugin.RepActions.CUSTOM, (Object)impact, (CommMessageAPI)null, (dialog != null) ? dialog.getTextPanel() : null, false, true), factionAPI.getId());
    }
    
    public void undoRepChange(final FactionAPI other, final InteractionDialogAPI dialog) {
        final String id = other.getId();
        final FactionCommissionIntel.RepChangeData change = this.repChanges.get(id);
        if (change == null) {
            return;
        }
        final CoreReputationPlugin.CustomRepImpact impact = new CoreReputationPlugin.CustomRepImpact();
        impact.delta = -change.delta;
        impact.delta = Math.max(0.0f, impact.delta - Global.getSettings().getFloat("factionCommissionRestoredRelationshipPenalty"));
        if (impact.delta > 0.0f) {
            Global.getSector().adjustPlayerReputation((Object)new CoreReputationPlugin.RepActionEnvelope(CoreReputationPlugin.RepActions.CUSTOM, (Object)impact, (CommMessageAPI)null, (dialog != null) ? dialog.getTextPanel() : null, false, true), id);
        }
        this.repChanges.remove(id);
    }
    
    public void undoAllRepChanges(final InteractionDialogAPI dialog) {
        for (final FactionCommissionIntel.RepChangeData data : new ArrayList(this.repChanges.values())) {
            this.undoRepChange(data.faction, dialog);
        }
    }
    
    protected boolean addEventFactorBulletPoints(final TooltipMakerAPI info, final IntelInfoPlugin.ListInfoMode mode, final boolean isUpdate, final Color tc, final float initPad) {
        if (isUpdate && this.getListInfoParam() instanceof EventFactor) {
            final EventFactor factor = (EventFactor)this.getListInfoParam();
            if (factor.isOneTime()) {
                factor.addBulletPointForOneTimeFactor((BaseEventIntel)this, info, tc, initPad);
            }
            return true;
        }
        return false;
    }
    
    public float getImageSizeForStageDesc(final Object stageId) {
        return 48.0f;
    }
    
    public float getImageIndentForStageDesc(final Object stageId) {
        return 16.0f;
    }
    
    public void addStageDescriptionText(final TooltipMakerAPI info, final float width, final Object stageId) {
        final float opad = 10.0f;
        final float small = 0.0f;
        final Color h = Misc.getHighlightColor();
        final BaseEventIntel.EventStageData stage = this.getDataFor(stageId);
        if (stage != null && stage.id.equals(this.getRank())) {
            this.addStageDesc(info, stageId, small, false);
        }
    }
    
    public void addStageDesc(final TooltipMakerAPI info, final Object stageId, final float initPad, final boolean forTooltip) {
        final float opad = 10.0f;
        final Color h = Misc.getHighlightColor();
        if (!forTooltip) {
            info.addPara("现在的职位 : %s", initPad, Color.ORANGE, new String[] { this.getRankForID((String)stageId).name.trim() });
            this.getRankInfoForTooltip(info, stageId, initPad);
            if (this.data.hasTag(AoTDCommisionTags.UP_RANK_AUTOMATICALLY)) {
                info.addPara("当你拥有的晋升点数足够你晋升时，你会自动升到更高级的岗位上", 5.0f);
            }
            else {
                info.addPara("Once you gather enough points for higher rank, you can go to one of Administrators from " + this.data.getFaction().getDisplayName() + " to ask for promotion", 5.0f);
            }
            if (!Misc.getPlayerMarkets(true).isEmpty() && !this.getData().hasTag(AoTDCommisionTags.DOES_NOT_CARE_ABOUT_PLAYER_COLONIES)) {
                final ButtonAPI button = info.addButton("Declare Independence", (Object)"secede", Misc.getNegativeHighlightColor(), Misc.getDarkPlayerColor(), Alignment.MID, CutStyle.ALL, 170.0f, 20.0f, 0.0f);
                button.getPosition().setXAlignOffset(info.getWidthSoFar() - button.getPosition().getWidth());
            }
        }
        else {
            this.getRankInfoForTooltip(info, stageId, initPad);
        }
    }
    
    public RankData getRankForID(final String id) {
        for (final RankData rank : this.data.ranks) {
            if (rank.id.equals(id)) {
                return rank;
            }
        }
        return null;
    }
    
    public void printSuppliesForTaking(final InteractionDialogAPI dialog) {
        final String[] res = { "supplies", "fuel" };
        final int[] qty = { (int)Math.max(Global.getSector().getPlayerFleet().getCargo().getMaxCapacity(), 1000.0f), (int)Global.getSector().getPlayerFleet().getCargo().getMaxFuel() };
        dialog.getTextPanel().addPara("基于你现在 %s的职位， 你能得到 %s 补给和 %s 燃料", Color.ORANGE, new String[] { this.getCurrentRankData().name, "" + qty[0], "" + qty[1] });
        dialog.getTextPanel().addPara("You will be able to ask for your supply package after 720 days", Misc.getTooltipTitleAndLightHighlightColor());
        Misc.showCost(dialog.getTextPanel(), "Supplies available", false, Color.ORANGE, Misc.getGrayColor(), res, qty);
        dialog.getTextPanel().addPara("You have available %s cargo space for supplies and %s for fuel", Color.ORANGE, new String[] { "" + QoLMisc.getFreeSpaceAvailable(Global.getSector().getPlayerFleet().getCargo()), "" + Global.getSector().getPlayerFleet().getCargo().getFreeFuelSpace() });
    }
    
    public boolean doesPlayerMeetCriteriaForCommision() {
        return this.data.getFaction().getRelToPlayer().isAtWorst(Commission.COMMISSION_REQ);
    }
    
    public void deliverCargo(final InteractionDialogAPI dialogAPI, final CargoAPI deliverCargo) {
        final int[] qty = { (int)Math.max(Global.getSector().getPlayerFleet().getCargo().getMaxCapacity(), 1000.0f), (int)Global.getSector().getPlayerFleet().getCargo().getMaxFuel() };
        deliverCargo.addCommodity("supplies", (float)qty[0]);
        deliverCargo.addCommodity("fuel", (float)qty[1]);
        Global.getSector().getPlayerFleet().getMemory().set("$aotd_wait_for_resupply", (Object)true, 720.0f);
        dialogAPI.getTextPanel().addPara("Supply package has been received!", Color.ORANGE);
    }
    
    public void printRequirements(final InteractionDialogAPI dialog) {
        CoreReputationPlugin.addRequiredStanding(this.data.getFaction(), Commission.COMMISSION_REQ, (PersonAPI)null, dialog.getTextPanel(), (TooltipMakerAPI)null, (Color)null, 0.0f, true);
        CoreReputationPlugin.addCurrentStanding(this.data.getFaction(), (PersonAPI)null, dialog.getTextPanel(), (TooltipMakerAPI)null, (Color)null, 0.0f);
    }
    
    public RankData getCurrentRankData() {
        return this.getRankForID(this.getRank());
    }
    
    public void getRankInfoForTooltip(final TooltipMakerAPI info, final Object stageId, final float initPad) {
        final RankData rank = this.getRankForID(this.getStageId(stageId));
        info.addPara("包含的权利:", 3.0f);
        info.addPara("salary: %s", initPad, Color.ORANGE, new String[] { Misc.getDGSCredits((float)rank.salary) });
        if (!this.data.hasTag(AoTDCommisionTags.DOES_NOT_CARE_ABOUT_PLAYER_COLONIES)) {
            if (rank.getAmountOfColoniesAbleToColonize() == 0) {
                info.addPara("Can't colonize any planets", Misc.getNegativeHighlightColor(), initPad);
            }
            else {
                info.addPara("允许你自主殖民或管理共计至多 %s 处殖民地", initPad, Misc.getTooltipTitleAndLightHighlightColor(), Color.ORANGE, new String[] { "" + rank.getAmountOfColoniesAbleToColonize() });
            }
            info.addPara("提示：受雇佣期间你管理的所有的殖民地在名义上都归 %s所有,因此 当你解除雇佣合同后,所有你管理的殖民地都会纳入到 %s名下，而非继续受你个人控制", initPad, Color.ORANGE, new String[] { this.data.getFaction().getDisplayNameWithArticle(), this.data.getFaction().getDisplayNameWithArticle() });
        }
        if (rank.getTarrifReduciton() > 0.0f) {
            info.addPara("关税减免额度 %s", initPad, Misc.getTooltipTitleAndLightHighlightColor(), Color.ORANGE, new String[] { "" + (int)rank.getTarrifReduciton() });
        }
        if (rank.hasTag(AoTDRankTags.ACCESS_TO_FACTION_BLUEPRINTS) && Global.getSettings().getModManager().isModEnabled("aotd_vok") && GPManager.isEnabled) {
            info.addPara("获取所属于 %s的武器，舰载机及舰船的蓝图", initPad, Misc.getTooltipTitleAndLightHighlightColor(), Color.ORANGE, new String[] { this.data.getFaction().getDisplayName() });
        }
        if (rank.hasTag(AoTDRankTags.FREE_STORAGE)) {
            info.addPara("免费使用所有%s名下的星球的仓库", initPad, Misc.getTooltipTitleAndLightHighlightColor(), Color.ORANGE, new String[] { this.data.getFaction().getDisplayName() });
        }
        if (rank.hasTag(AoTDRankTags.HAVE_RESEARCH_PERMIT) && Global.getSettings().getModManager().isModEnabled("aotd_vok")) {
            info.addPara("允许你独立进行“人之领余烬”相关的科学研究", Misc.getPositiveHighlightColor(), initPad);
        }
        if (rank.hasTag(AoTDRankTags.CAN_INTIMIDATE_CARGO_PATROL_FLEETS)) {
            info.addPara("可以拒绝巡逻队搜查你的货仓内的货物", Misc.getPositiveHighlightColor(), initPad);
        }
        if (rank.hasTag(AoTDRankTags.COLONY_CONTRACTS)) {
            info.addPara("Ability to sign permanent colony deals with faction (WIP)", Misc.getPositiveHighlightColor(), initPad);
        }
        if (!rank.isLeavingAnOption()) {
            info.addPara("You are now a permanent member of %s. Any act against %s interest or outright hostile attitude will lead to execution!", initPad, Misc.getTooltipTitleAndLightHighlightColor(), Color.ORANGE, new String[] { this.data.getFaction().getDisplayNameWithArticle(), this.data.getFaction().getDisplayNameWithArticle() });
        }
        info.addPara("警告 : 如果在雇佣期间你和%s的关系降低到%s及以下, 这种敌对的行为会使你们之间的雇佣合同立刻终止并对你的舰队发起悬赏", 5.0f, Misc.getNegativeHighlightColor(), Misc.getTooltipTitleAndLightHighlightColor(), new String[] { this.getCurrentlyCommisonedFaction().getDisplayName(), "-50" });
    }
    
    public TooltipMakerAPI.TooltipCreator getStageTooltipImpl(final Object stageId) {
        final BaseEventIntel.EventStageData esd = this.getDataFor(stageId);
        return (TooltipMakerAPI.TooltipCreator)((esd != null && this.stages.contains(esd)) ? new TooltipMakerAPI.TooltipCreator() {
            public boolean isTooltipExpandable(final Object tooltipParam) {
                return true;
            }
            
            public float getTooltipWidth(final Object tooltipParam) {
                return 600.0f;
            }
            
            public void createTooltip(final TooltipMakerAPI tooltip, final boolean expanded, final Object tooltipParam) {
                final float opad = 5.0f;
                tooltip.addTitle("Rank : " + AoTDCommIntelPlugin.this.getRankForID((String)esd.id).name);
                tooltip.addPara(AoTDCommIntelPlugin.this.getRankForID((String)esd.id).getDescription(), 3.0f);
                AoTDCommIntelPlugin.this.addStageDesc(tooltip, esd.id, opad, true);
                esd.addProgressReq(tooltip, opad);
            }
        } : null);
    }
    
    public TooltipMakerAPI.TooltipCreator getStageTooltip(final Object stageId) {
        return super.getStageTooltip(stageId);
    }
    
    public String getStageId(final Object id) {
        return (String)id;
    }
    
    protected String getName() {
        return "Commission " + this.data.getFaction().getDisplayName();
    }
    
    public String getIcon() {
        return this.data.getFaction().getCrest();
    }
    
    protected String getStageIconImpl(final Object stageId) {
        final String stage = (String)stageId;
        return this.data.getFaction().getCrest();
    }
    
    public void setProgress(int progress) {
        if (this.progress == progress) {
            return;
        }
        if (progress < 0) {
            progress = 0;
        }
        if (progress > this.maxProgress) {
            progress = this.maxProgress;
        }
        final BaseEventIntel.EventStageData prev = this.getLastActiveStage(true);
        this.prevProgressDeltaWasPositive = (this.progress < progress);
        if ((this.progress = progress) < 0) {
            progress = 0;
        }
        if (progress > this.getMaxProgress()) {
            progress = this.getMaxProgress();
        }
        for (final BaseEventIntel.EventStageData esd : this.getStages()) {
            if (esd.wasEverReached && esd.isOneOffEvent && !esd.isRepeatable) {
                continue;
            }
            if (!esd.randomized) {
                continue;
            }
            if (esd.rollData != null && !esd.rollData.equals("random_event_none") && progress <= esd.progressToResetAt) {
                this.resetRandomizedStage(esd);
            }
            if ((esd.rollData != null && !esd.rollData.equals("random_event_none")) || progress < esd.progressToRollAt) {
                continue;
            }
            this.rollRandomizedStage(esd);
            if (esd.rollData != null) {
                continue;
            }
            esd.rollData = "random_event_none";
        }
        for (final BaseEventIntel.EventStageData curr : this.getStages()) {
            if (curr.progress <= prev.progress && !prev.wasEverReached) {
                if (prev.rollData == null) {
                    continue;
                }
                if (prev.rollData.equals("random_event_none")) {
                    continue;
                }
            }
            if (curr.progress <= progress && curr != null && !prev.wasEverReached) {
                if (curr.sendIntelUpdateOnReaching && curr.progress > 0 && (prev == null || prev.progress < curr.progress)) {
                    this.sendUpdateIfPlayerHasIntel((Object)curr, this.getTextPanelForStageChange());
                }
                this.notifyStageReached(curr);
                curr.rollData = null;
                curr.wasEverReached = true;
                progress = this.getProgress();
            }
        }
    }
    
    protected void notifyStageReached(final BaseEventIntel.EventStageData stage) {
        super.notifyStageReached(stage);
        if (this.getData().hasTag(AoTDCommisionTags.UP_RANK_AUTOMATICALLY)) {
            this.setRank(this.getStageId(stage.id));
        }
    }
    
    public void generateNewAdministrators() {
    }
    
    public void endCommision(final InteractionDialogAPI dialog, final boolean isRebelling) {
        this.commisionValid = false;
        for (final MarketAPI marketAPI : Global.getSector().getEconomy().getMarketsCopy()) {
            if (marketAPI.getFaction().getId().equals(this.data.factionID)) {
                marketAPI.getTariff().unmodifyFlat("aotd_commision");
            }
        }
        AoTDFreeStorageComm.runCleanUpScript(this.data.getFaction());
        Global.getSector().getListenerManager().removeListener((Object)this);
        Global.getSector().removeScript((EveryFrameScript)this);
        if (!this.data.hasTag(AoTDCommisionTags.DOES_NOT_CARE_ABOUT_PLAYER_COLONIES) && !isRebelling) {
            for (final MarketAPI factionMarket : Misc.getFactionMarkets(this.data.getFaction())) {
                if (factionMarket.isPlayerOwned()) {
                    final PersonAPI person = factionMarket.getFaction().createRandomPerson();
                    factionMarket.setAdmin(person);
                    factionMarket.setPlayerOwned(false);
                    AoTDNexMarketUtil.addOrUpdateOfficials(factionMarket);
                }
            }
        }
        else {
            for (final MarketAPI factionMarket : Misc.getFactionMarkets(this.data.getFaction())) {
                if (factionMarket.isPlayerOwned()) {
                    setMarketFaction(factionMarket, Global.getSector().getPlayerFaction().getId(), false);
                }
            }
        }
        final MonthlyReport report = SharedData.getData().getCurrentReport();
        final MonthlyReport.FDNode fleetNode = report.getNode(new String[] { MonthlyReport.FLEET });
        fleetNode.name = "Fleet";
        fleetNode.custom = MonthlyReport.FLEET;
        fleetNode.tooltipCreator = (TooltipMakerAPI.TooltipCreator)report.getMonthlyReportTooltip();
        final FactionAPI faction = this.data.getFaction();
        final float stipend = (float)this.getCurrentRankData().salary;
        final MonthlyReport.FDNode stipendNode = report.getNode(fleetNode, new String[] { "node_id_stipend_" + this.data.getFaction().getId() });
        stipendNode.income = 0.0f;
        fleetNode.getChildren().remove(stipendNode);
        this.undoAllRepChanges(dialog);
        if (isRebelling) {
            this.makeHostile(this.getCurrentlyCommisonedFaction(), dialog);
        }
        this.endImmediately();
        Global.getSector().getCharacterData().getMemory().unset("$fcm_faction");
    }
    
    public void endImmediately() {
        super.endImmediately();
    }
    
    public void advance(final float amount) {
        super.advance(amount);
    }
    
    public void createLargeDescription(final CustomPanelAPI panel, final float width, final float height) {
        final float opad = 10.0f;
        this.uiWidth = width;
        final TooltipMakerAPI main = panel.createUIElement(width, height, true);
        main.setTitleOrbitronVeryLarge();
        main.addTitle(this.getName(), Misc.getBasePlayerColor());
        final EventProgressBarAPI bar = main.addEventProgressBar((BaseEventIntel)this, 100.0f);
        final TooltipMakerAPI.TooltipCreator barTC = this.getBarTooltip();
        if (barTC != null) {
            main.addTooltipToPrevious(barTC, TooltipMakerAPI.TooltipLocation.BELOW, false);
        }
        for (final BaseEventIntel.EventStageData curr : this.stages) {
            if (curr.progress <= 0) {
                continue;
            }
            if ("random_event_none".equals(curr.rollData)) {
                continue;
            }
            if (curr.wasEverReached && curr.isOneOffEvent && !curr.isRepeatable) {
                continue;
            }
            if (curr.hideIconWhenPastStageUnlessLastActive && curr.progress <= this.progress && this.getLastActiveStage(true) != curr) {
                continue;
            }
            final BaseEventIntel.EventStageDisplayData data = this.createDisplayData(curr.id);
            final UIComponentAPI marker = main.addEventStageMarker(data);
            final float xOff = bar.getXCoordinateForProgress((float)curr.progress) - bar.getPosition().getX();
            marker.getPosition().aboveLeft((UIComponentAPI)bar, data.downLineLength).setXAlignOffset(xOff - data.size / 2.0f - 1.0f);
            final TooltipMakerAPI.TooltipCreator tc = this.getStageTooltip(curr.id);
            if (tc == null) {
                continue;
            }
            main.addTooltipTo(tc, marker, TooltipMakerAPI.TooltipLocation.LEFT, false);
        }
        final UIComponentAPI marker2 = main.addEventProgressMarker((BaseEventIntel)this);
        final float xOff2 = bar.getXCoordinateForProgress((float)this.progress) - bar.getPosition().getX();
        marker2.getPosition().belowLeft((UIComponentAPI)bar, -this.getBarProgressIndicatorHeight() * 0.5f - 2.0f).setXAlignOffset(xOff2 - this.getBarProgressIndicatorWidth() / 2.0f - 1.0f);
        main.addSpacer(opad);
        main.addSpacer(opad);
        for (final BaseEventIntel.EventStageData curr : this.stages) {
            if (curr.wasEverReached && curr.isOneOffEvent && !curr.isRepeatable) {
                continue;
            }
            this.addStageDescriptionWithImage(main, curr.id);
        }
        final float barW = this.getBarWidth();
        float factorWidth = (barW - opad) / 2.0f;
        if (this.withMonthlyFactors() != this.withOneTimeFactors()) {
            factorWidth = (float)(int)(barW * 0.6f);
        }
        final TooltipMakerAPI mFac = main.beginSubTooltip(factorWidth);
        final Color c = this.getFactionForUIColors().getBaseUIColor();
        final Color bg = this.getFactionForUIColors().getDarkUIColor();
        mFac.addSectionHeading("Monthly factors", c, bg, Alignment.MID, opad).getPosition().setXAlignOffset(0.0f);
        final float strW = 40.0f;
        final float rh = 20.0f;
        mFac.beginTable2(this.getFactionForUIColors(), rh, false, false, new Object[] { "Monthly factors", factorWidth - strW - 3.0f, "Progress", strW });
        for (final EventFactor factor : this.factors) {
            if (factor.isOneTime()) {
                continue;
            }
            if (!factor.shouldShow((BaseEventIntel)this)) {
                continue;
            }
            final String desc = factor.getDesc((BaseEventIntel)this);
            if (desc != null) {
                mFac.addRowWithGlow(new Object[] { Alignment.LMID, factor.getDescColor((BaseEventIntel)this), desc, Alignment.RMID, factor.getProgressColor((BaseEventIntel)this), factor.getProgressStr((BaseEventIntel)this) });
                final TooltipMakerAPI.TooltipCreator t = factor.getMainRowTooltip((BaseEventIntel)this);
                if (t != null) {
                    mFac.addTooltipToAddedRow(t, TooltipMakerAPI.TooltipLocation.RIGHT, false);
                }
            }
            factor.addExtraRows(mFac, (BaseEventIntel)this);
        }
        mFac.addTable("None", -1, opad);
        mFac.getPrev().getPosition().setXAlignOffset(-5.0f);
        main.endSubTooltip();
        final TooltipMakerAPI oFac = main.beginSubTooltip(factorWidth);
        oFac.addSectionHeading("Recent one-time factors", c, bg, Alignment.MID, opad).getPosition().setXAlignOffset(0.0f);
        oFac.beginTable2(this.getFactionForUIColors(), 20.0f, false, false, new Object[] { "One-time factors", factorWidth - strW - 3.0f, "Progress", strW });
        final List<EventFactor> reversed = new ArrayList<EventFactor>(this.factors);
        Collections.reverse(reversed);
        for (final EventFactor factor2 : reversed) {
            if (!factor2.isOneTime()) {
                continue;
            }
            if (!factor2.shouldShow((BaseEventIntel)this)) {
                continue;
            }
            final String desc2 = factor2.getDesc((BaseEventIntel)this);
            if (desc2 != null) {
                oFac.addRowWithGlow(new Object[] { Alignment.LMID, factor2.getDescColor((BaseEventIntel)this), desc2, Alignment.RMID, factor2.getProgressColor((BaseEventIntel)this), factor2.getProgressStr((BaseEventIntel)this) });
                final TooltipMakerAPI.TooltipCreator t2 = factor2.getMainRowTooltip((BaseEventIntel)this);
                if (t2 != null) {
                    oFac.addTooltipToAddedRow(t2, TooltipMakerAPI.TooltipLocation.LEFT);
                }
            }
            factor2.addExtraRows(oFac, (BaseEventIntel)this);
        }
        oFac.addTable("None", -1, opad);
        oFac.getPrev().getPosition().setXAlignOffset(-5.0f);
        main.endSubTooltip();
        final float factorHeight = Math.max(mFac.getHeightSoFar(), oFac.getHeightSoFar());
        mFac.setHeightSoFar(factorHeight);
        oFac.setHeightSoFar(factorHeight);
        if (this.withMonthlyFactors() && this.withOneTimeFactors()) {
            main.addCustom((UIComponentAPI)mFac, opad * 2.0f);
            main.addCustomDoNotSetPosition((UIComponentAPI)oFac).getPosition().rightOfTop((UIComponentAPI)mFac, opad);
        }
        else if (this.withMonthlyFactors()) {
            main.addCustom((UIComponentAPI)mFac, opad * 2.0f);
        }
        else if (this.withOneTimeFactors()) {
            main.addCustom((UIComponentAPI)oFac, opad * 2.0f);
        }
        panel.addUIElement(main).inTL(0.0f, 0.0f);
    }
    
    protected void advanceImpl(final float amount) {
        if (Misc.getFactionMarkets(this.getCurrentlyCommisonedFaction().getId()).isEmpty()) {
            this.endCommision(null, false);
            return;
        }
        if (this.getCurrentlyCommisonedFaction().getRelToPlayer().isHostile()) {
            final String[] strs = { this.getCurrentlyCommisonedFaction().getDisplayName() };
            final MessageIntel intel = new MessageIntel("Commission contract with %s : terminated!", Misc.getNegativeHighlightColor(), strs, new Color[] { Color.ORANGE });
            intel.addLine("Due to hostile actions taken against " + strs[0] + " they have terminated contract and put bounty on our head!");
            intel.setIcon(this.getCurrentlyCommisonedFaction().getCrest());
            intel.setSound(BaseIntelPlugin.getSoundColonyThreat());
            Global.getSector().getCampaignUI().addMessage((IntelInfoPlugin)intel, CommMessageAPI.MessageClickAction.INTEL_TAB, (Object)intel);
            this.endCommision(null, false);
            return;
        }
        if (!this.commisionValid) {
            return;
        }
        super.advanceImpl(amount);
        final Iterator<AoTDCommIntelPlugin> listeners = Global.getSector().getListenerManager().getListeners((Class)AoTDCommIntelPlugin.class).iterator();
        boolean foundAlreadyOne = false;
        while (listeners.hasNext()) {
            final AoTDCommIntelPlugin plugin = listeners.next();
            if (plugin == this && !foundAlreadyOne) {
                foundAlreadyOne = true;
            }
            else {
                listeners.remove();
            }
        }
        if (QoLMisc.isCommissioned() && this.data != null && this.data.ranks != null && this.getCurrentRankData() != null && !this.isDone()) {
            for (final MarketAPI marketAPI : Global.getSector().getEconomy().getMarketsCopy()) {
                if (marketAPI.getFaction().isPlayerFaction()) {
                    setMarketFaction(marketAPI, this.data.factionID, false);
                }
                if (marketAPI.getFaction().getId().equals(this.data.factionID)) {
                    marketAPI.getTariff().modifyFlat("aotd_commision", -(this.getCurrentRankData().getTarrifReduciton() / 100.0f), "Commission");
                }
            }
            this.makeRepChanges(null);
        }
    }
    
    public static void setMarketFaction(final MarketAPI marketAPI, final String factionID, final boolean joiningComm) {
        if (marketAPI.hasTag("nex_playerOutpost")) {
            return;
        }
        if (marketAPI.getCommDirectory().getEntriesCopy().isEmpty()) {
            AoTDNexMarketUtil.addOrUpdateOfficials(marketAPI);
        }
        marketAPI.setFactionId(factionID);
        marketAPI.setPlayerOwned(true);
        marketAPI.getPrimaryEntity().setFaction(factionID);
        for (final SectorEntityToken connectedEntity : marketAPI.getConnectedEntities()) {
            connectedEntity.setFaction(factionID);
        }
        for (final Industry industry : marketAPI.getIndustries()) {
            if (industry instanceof OrbitalStation) {
                final CampaignFleetAPI fleet = (CampaignFleetAPI)ReflectionUtilis.getPrivateVariable("stationFleet", (Object)industry);
                if (fleet == null) {
                    continue;
                }
                fleet.setFaction(factionID);
            }
        }
        if (joiningComm) {
            for (final CampaignFleetAPI fleet2 : marketAPI.getStarSystem().getFleets()) {
                if (fleet2.getFaction().isPlayerFaction() && !fleet2.isPlayerFleet()) {
                    fleet2.setFaction(factionID, true);
                }
            }
        }
        for (final CommDirectoryEntryAPI commDirectoryEntryAPI : marketAPI.getCommDirectory().getEntriesCopy()) {
            if (commDirectoryEntryAPI.getEntryData() instanceof final PersonAPI personAPI) {
                personAPI.setFaction(factionID);
            }
        }
    }
    
    public int getProgress() {
        return super.getProgress();
    }
    
    public ArrayList<String> getRanksForPromotion() {
        final ArrayList<String> ranks = new ArrayList<String>();
        boolean aboveRank = false;
        for (final RankData rank : this.data.ranks) {
            if (this.getRank().equals(rank.id)) {
                aboveRank = true;
            }
            else {
                if (!aboveRank) {
                    continue;
                }
                ranks.add(rank.id);
            }
        }
        return ranks;
    }
    
    public Color getBarColor() {
        Color color = AoTDCommIntelPlugin.BAR_COLOR;
        color = Misc.interpolateColor(color, Color.black, 0.25f);
        return color;
    }
    
    public boolean canColonize() {
        return this.canBuyMarket(this.getRank());
    }
    
    public void printWarning(final InteractionDialogAPI dialog) {
        dialog.getTextPanel().addPara("Due to your colonial holdings we are going to propose you one of governor titles, instead of mercenary titles.", Color.ORANGE);
        dialog.getTextPanel().addPara("Not only that, but we require all of your colonies to serve under our banner, we will of course let you keep control over them, but they will belong to " + this.data.getFaction().getDisplayNameWithArticle(), Color.ORANGE);
    }
    
    public boolean canBuyMarket(final String currentRank) {
        final RankData data = this.getRankForID(currentRank);
        return data.hasTag(AoTDRankTags.NONRESTRICTIVE_COLONIZATION) || this.getAmountOfCurrentColonies() < data.getAmountOfColoniesAbleToColonize();
    }
    
    public boolean hasAttainedThisRankBefore(final String rankId) {
        for (final RankData rank : this.data.ranks) {
            if (rank.getId().equals(rankId)) {
                return true;
            }
            if (rank.getId().equals(this.getCurrentRankData().getId())) {
                break;
            }
        }
        return false;
    }
    
    public boolean canResign() {
        return this.getCurrentRankData().isLeavingAnOption();
    }
    
    public int getAmountOfCurrentColonies() {
        int amount = 0;
        for (final MarketAPI playerMarket : Misc.getPlayerMarkets(true)) {
            if (playerMarket.hasTag("nex_playerOutpost")) {
                continue;
            }
            ++amount;
        }
        return amount;
    }
    
    public TooltipMakerAPI.TooltipCreator getBarTooltip() {
        return super.getBarTooltip();
    }
    
    public boolean withMonthlyFactors() {
        return true;
    }
    
    public void buttonPressConfirmed(final Object buttonId, final IntelUIAPI ui) {
        if (buttonId == AoTDCommIntelPlugin.BUTTON_DELETE) {
            this.endImmediately();
            ui.recreateIntelUI();
            return;
        }
        final BasePopUpDialog dialog = (BasePopUpDialog)new RebelionEventDialog("Start Rebellion", this.getCurrentlyCommisonedFaction(), ui);
        final CustomPanelAPI panelAPI = Global.getSettings().createCustom(800.0f, 300.0f, (CustomUIPanelPlugin)dialog);
        final UIPanelAPI panelAPI2 = ProductionUtil.getCoreUI();
        dialog.init(panelAPI, panelAPI2.getPosition().getCenterX() - panelAPI.getPosition().getWidth() / 2.0f, panelAPI2.getPosition().getCenterY() + panelAPI.getPosition().getHeight() / 2.0f, true);
        ui.updateUIForItem((IntelInfoPlugin)this);
    }
    
    public float getCreditsForRetirement() {
        float currMoney = 0.0f;
        for (final MarketAPI playerMarket : Misc.getPlayerMarkets(true)) {
            currMoney += playerMarket.getNetIncome() / 2.0f;
        }
        currMoney += this.getCurrentRankData().salary / 2;
        return currMoney;
    }
    
    static {
        AoTDCommIntelPlugin.optionColor = new Color(239, 139, 24);
        AoTDCommIntelPlugin.BAR_COLOR = Global.getSettings().getColor("progressBarFleetPointsColor");
        AoTDCommIntelPlugin.RESEARCH_KEY = "$aotd_commision";
        AoTDCommIntelPlugin.RANK_KEY = "$aotd_rank";
    }
}
